#include "gesture_demostration_objects.h"
#include "gesture_demostration_resources.h"
#include "built_in.h"
#define W_STROBE() TFT_WR = 0; asm nop; TFT_WR = 1


// TFT module connections
sbit TFT_CS                    at GPIO_PORTJ_AHB_DATA.B3;
char TFT_DataPort              at GPIO_PORTR_DATA;
sbit TFT_RD                    at GPIO_PORTJ_AHB_DATA.B5;
sbit TFT_RS                    at GPIO_PORTJ_AHB_DATA.B4;
sbit TFT_RST                   at GPIO_PORTJ_AHB_DATA.B2;
sbit TFT_WR                    at GPIO_PORTJ_AHB_DATA.B6;

sbit TFT_CS_Direction          at GPIO_PORTJ_AHB_DATA.B3;
char TFT_DataPort_Direction    at GPIO_PORTR_DATA;
sbit TFT_RD_Direction          at GPIO_PORTJ_AHB_DATA.B5;
sbit TFT_RS_Direction          at GPIO_PORTJ_AHB_DATA.B4;
sbit TFT_RST_Direction         at GPIO_PORTJ_AHB_DATA.B2;
sbit TFT_WR_Direction          at GPIO_PORTJ_AHB_DATA.B6;
// End TFT module connections

// Touch Panel module connections
// End Touch Panel module connections

// Global variables
unsigned int Xcoord, Ycoord;
char PenDown;
void *PressedObject;
int PressedObjectType;
unsigned int caption_length, caption_height;
unsigned int display_width, display_height;

int _object_count;
unsigned short object_pressed;
TButton_Round *local_round_button;
TButton_Round *exec_round_button;
int round_button_order;
TLabel *local_label;
TLabel *exec_label;
int label_order;
TBox_Round *local_round_box;
TBox_Round *exec_round_box;
int box_round_order;

typedef struct {
  unsigned long  config;
  unsigned int   displayWidth;
  unsigned int   displayHeight;
  unsigned int   horizontalFrontPorch;
  unsigned int   horizontalBackPorch;
  unsigned int   horizontalSyncWidth;
  unsigned short verticalFrontPorch;
  unsigned short verticalBackPorch;
  unsigned short verticalSyncWidth;
  unsigned short biasLineCount;
} TLCDRasterTiming;

TLCDRasterTiming Timings;

static void InitializeTouchPanel() {

  GPIO_Digital_Output(&GPIO_PORTM, _GPIO_PINMASK_6);
  GPIO_PORTM_DATA.B6 = 1;
  SPI1_Init_Advanced(15000000, _SPI_MASTER, _SPI_8_BIT | _SPI_CLK_IDLE_LOW | _SPI_FIRST_CLK_EDGE_TRANSITION, &_GPIO_MODULE_SPI1_B5E45_AHB);
  uDMA_Init();
  EPI_SDRAM_Init();
//  TFTIntern_SetDefaultMode();
  TFTIntern_SetDisplayRotation(_TFT_INTERN_ROTATE_180);                                                                                    // TODO _TFT_INTERN_ROTATE_180


  GPIO_Alternate_Function_Enable(&_GPIO_MODULE_LCD_RASTER_24BPP);
  SYSCTL_RCGCLCD = 0x01;
  TFTIntern_ModeSet(_TFT_INTERN_MODE_RASTER | _TFT_INTERN_MODE_AUTO_UFLOW_RESTART, 6400000, 120000000);
  TFTIntern_RasterConfigSet(_RASTER_FMT_ACTIVE_PALETTIZED_16BIT | _RASTER_LOAD_DATA_ONLY, 0);
  Timings.config =  _RASTER_TIMING_SYNCS_ON_RISING_PIXCLK | _RASTER_TIMING_ACTIVE_HIGH_OE | _RASTER_TIMING_ACTIVE_HIGH_PIXCLK | _RASTER_TIMING_ACTIVE_HIGH_HSYNC | _RASTER_TIMING_ACTIVE_HIGH_VSYNC;
  Timings.displayWidth  = 320;
  Timings.displayHeight = 240;
  Timings.horizontalFrontPorch = 20;
  Timings.horizontalBackPorch  = 38;
  Timings.horizontalSyncWidth  = 40;
  Timings.verticalFrontPorch   = 4;
  Timings.verticalBackPorch    = 15;
  Timings.verticalSyncWidth    = 3;
  Timings.biasLineCount        = 0;
  TFTIntern_RasterTimingSet(&Timings);
  TFTIntern_SetDisplaySize(320, 240);
  TFTIntern_DMAConfigSet(_TFT_INTERN_DMA_PRIORITY_7 | _TFT_INTERN_DMA_FIFORDY_512_WORDS | _TFT_INTERN_DMA_BURST_16 | _TFT_INTERN_DMA_BYTE_ORDER_0123 | _TFT_INTERN_DMA_PING_PONG);
  TFTIntern_RasterFrameBufferSet(0, (unsigned long *)(0x10000000+0x0),153600);
  TFTIntern_RasterFrameBufferSet(1, (unsigned long *)(0x10000000+0x0),153600);
  TFTIntern_RasterPaletteSet(_TFT_INTERN_PALETTE_TYPE_DIRECT, (unsigned long *)(0x10000000), 0, 0, 0);
  TFTIntern_SetMemoryStartAddr((unsigned int *)(0x10000000));
  TFTIntern_RasterEnable();

  PenDown = 0;
  PressedObject = 0;
  PressedObjectType = -1;
}


/////////////////////////
  TScreen*  CurrentScreen;

  TScreen                Screen1;
  TBox_Round             BoxRound1;
  TButton_Round          ButtonRound1;
char ButtonRound1_Caption[22] = "Mikroe Color Selector";

  TButton_Round          ButtonRound5;
char ButtonRound5_Caption[2] = "+";

  TButton_Round          ButtonRound6;
char ButtonRound6_Caption[2] = "-";

  TButton_Round          ButtonRound7;
char ButtonRound7_Caption[2] = "+";

  TButton_Round          ButtonRound8;
char ButtonRound8_Caption[2] = "-";

  TLabel                 Label1;
char Label1_Caption[20] = "Vertical Tabs (2-9)";

  TLabel                 Label2;
char Label2_Caption[22] = "Horizontal Tabs (2-9)";

  TLabel                 Label3;
char Label3_Caption[8] = "    3  ";

  TLabel                 Label4;
char Label4_Caption[8] = "    3  ";

  TLabel                 Label5;
char Label5_Caption[26] = "Use Swipes (Up,Down,Left,";

  TLabel                 Label6;
char Label6_Caption[28] = "Right), to move the cursor.";

  TLabel                 Label7;
char Label7_Caption[27] = "Use Zoom (In,Out) gestures";

  TLabel                 Label8;
char Label8_Caption[22] = "to change fill color.";

  TLine                  Line1;
  TButton_Round          * const code Screen1_Buttons_Round[5]=
         {
         &ButtonRound1,        
         &ButtonRound5,        
         &ButtonRound6,        
         &ButtonRound7,        
         &ButtonRound8         
         };
  TLabel                 * const code Screen1_Labels[8]=
         {
         &Label1,              
         &Label2,              
         &Label3,              
         &Label4,              
         &Label5,              
         &Label6,              
         &Label7,              
         &Label8               
         };
  TBox_Round             * const code Screen1_Boxes_Round[1]=
         {
         &BoxRound1            
         };
  TLine                  * const code Screen1_Lines[1]=
         {
         &Line1                
         };

  TScreen                Screen2;
  TBox_Round             BoxRound2;
  TBox_Round             BoxRound3;
  TButton_Round          ButtonRound2;
char ButtonRound2_Caption[5] = "Exit";

  TBox_Round             BoxRound4;
  TButton_Round          ButtonRound3;
char ButtonRound3_Caption[10] = "Fill Area";

  TButton_Round          ButtonRound4;
char ButtonRound4_Caption[6] = "Reset";

  TButton_Round          * const code Screen2_Buttons_Round[3]=
         {
         &ButtonRound2,        
         &ButtonRound3,        
         &ButtonRound4         
         };
  TBox_Round             * const code Screen2_Boxes_Round[3]=
         {
         &BoxRound2,           
         &BoxRound3,           
         &BoxRound4            
         };



static void InitializeObjects() {
  Screen1.Color                     = 0x3186;
  Screen1.Width                     = 320;
  Screen1.Height                    = 240;
  Screen1.Buttons_RoundCount        = 5;
  Screen1.Buttons_Round             = Screen1_Buttons_Round;
  Screen1.LabelsCount               = 8;
  Screen1.Labels                    = Screen1_Labels;
  Screen1.Boxes_RoundCount          = 1;
  Screen1.Boxes_Round               = Screen1_Boxes_Round;
  Screen1.LinesCount                = 1;
  Screen1.Lines                     = Screen1_Lines;
  Screen1.ObjectsCount              = 15;
  Screen1.OnSwipeUpPtr    = 0;
  Screen1.OnSwipeDownPtr  = 0;
  Screen1.OnSwipeLeftPtr  = 0;
  Screen1.OnSwipeRightPtr = 0;
  Screen1.OnZoomInPtr     = 0;
  Screen1.OnZoomOutPtr    = 0;

  Screen2.Color                     = 0x3186;
  Screen2.Width                     = 320;
  Screen2.Height                    = 240;
  Screen2.Buttons_RoundCount        = 3;
  Screen2.Buttons_Round             = Screen2_Buttons_Round;
  Screen2.LabelsCount               = 0;
  Screen2.Boxes_RoundCount          = 3;
  Screen2.Boxes_Round               = Screen2_Boxes_Round;
  Screen2.LinesCount                = 0;
  Screen2.ObjectsCount              = 6;
  Screen2.OnSwipeUpPtr    = Screen2OnSwipeUp;
  Screen2.OnSwipeDownPtr  = Screen2OnSwipeDown;
  Screen2.OnSwipeLeftPtr  = Screen2OnSwipeLeft;
  Screen2.OnSwipeRightPtr = Screen2OnSwipeRight;
  Screen2.OnZoomInPtr     = Screen2OnZoomIn;
  Screen2.OnZoomOutPtr    = Screen2OnZoomOut;


  BoxRound1.OwnerScreen     = &Screen1;
  BoxRound1.Order           = 0;
  BoxRound1.Left            = 5;
  BoxRound1.Top             = 4;
  BoxRound1.Width           = 310;
  BoxRound1.Height          = 230;
  BoxRound1.Pen_Width       = 4;
  BoxRound1.Pen_Color       = 0xFE66;
  BoxRound1.Visible         = 1;
  BoxRound1.Active          = 1;
  BoxRound1.Transparent     = 1;
  BoxRound1.Gradient        = 0;
  BoxRound1.Gradient_Orientation = 0;
  BoxRound1.Gradient_Start_Color = 0xFFFF;
  BoxRound1.Gradient_End_Color = 0xC618;
  BoxRound1.Color           = 0x3186;
  BoxRound1.PressColEnabled = 0;
  BoxRound1.Press_Color     = 0xE71C;
  BoxRound1.Corner_Radius   = 6;

  ButtonRound1.OwnerScreen     = &Screen1;
  ButtonRound1.Order           = 1;
  ButtonRound1.Left            = 31;
  ButtonRound1.Top             = 31;
  ButtonRound1.Width           = 260;
  ButtonRound1.Height          = 65;
  ButtonRound1.Pen_Width       = 3;
  ButtonRound1.Pen_Color       = 0xFE66;
  ButtonRound1.Visible         = 1;
  ButtonRound1.Active          = 1;
  ButtonRound1.Transparent     = 1;
  ButtonRound1.Caption         = ButtonRound1_Caption;
  ButtonRound1.TextAlign       = _taCenter;
  ButtonRound1.TextAlignVertical= _tavMiddle;
  ButtonRound1.FontName        = Tahoma24x24_Bold;
  ButtonRound1.PressColEnabled = 1;
  ButtonRound1.Font_Color      = 0xCE79;
  ButtonRound1.VerticalText    = 0;
  ButtonRound1.Gradient        = 0;
  ButtonRound1.Gradient_Orientation = 0;
  ButtonRound1.Gradient_Start_Color = 0xFFFF;
  ButtonRound1.Gradient_End_Color = 0xC618;
  ButtonRound1.Color           = 0x3186;
  ButtonRound1.Press_Color     = 0x632C;
  ButtonRound1.Corner_Radius   = 4;
  ButtonRound1.OnClickPtr      = ButtonRound1OnClick;

  ButtonRound5.OwnerScreen     = &Screen1;
  ButtonRound5.Order           = 2;
  ButtonRound5.Left            = 70;
  ButtonRound5.Top             = 190;
  ButtonRound5.Width           = 35;
  ButtonRound5.Height          = 35;
  ButtonRound5.Pen_Width       = 2;
  ButtonRound5.Pen_Color       = 0xCE79;
  ButtonRound5.Visible         = 1;
  ButtonRound5.Active          = 1;
  ButtonRound5.Transparent     = 1;
  ButtonRound5.Caption         = ButtonRound5_Caption;
  ButtonRound5.TextAlign       = _taCenter;
  ButtonRound5.TextAlignVertical= _tavMiddle;
  ButtonRound5.FontName        = Tahoma21x25_Regular;
  ButtonRound5.PressColEnabled = 1;
  ButtonRound5.Font_Color      = 0xFE66;
  ButtonRound5.VerticalText    = 0;
  ButtonRound5.Gradient        = 0;
  ButtonRound5.Gradient_Orientation = 0;
  ButtonRound5.Gradient_Start_Color = 0xFFFF;
  ButtonRound5.Gradient_End_Color = 0xC618;
  ButtonRound5.Color           = 0x3186;
  ButtonRound5.Press_Color     = 0x632C;
  ButtonRound5.Corner_Radius   = 3;
  ButtonRound5.OnClickPtr      = ButtonRound5OnClick;

  ButtonRound6.OwnerScreen     = &Screen1;
  ButtonRound6.Order           = 3;
  ButtonRound6.Left            = 30;
  ButtonRound6.Top             = 190;
  ButtonRound6.Width           = 35;
  ButtonRound6.Height          = 35;
  ButtonRound6.Pen_Width       = 2;
  ButtonRound6.Pen_Color       = 0xCE79;
  ButtonRound6.Visible         = 1;
  ButtonRound6.Active          = 1;
  ButtonRound6.Transparent     = 1;
  ButtonRound6.Caption         = ButtonRound6_Caption;
  ButtonRound6.TextAlign       = _taCenter;
  ButtonRound6.TextAlignVertical= _tavMiddle;
  ButtonRound6.FontName        = Tahoma21x25_Regular;
  ButtonRound6.PressColEnabled = 1;
  ButtonRound6.Font_Color      = 0xFE66;
  ButtonRound6.VerticalText    = 0;
  ButtonRound6.Gradient        = 0;
  ButtonRound6.Gradient_Orientation = 0;
  ButtonRound6.Gradient_Start_Color = 0xFFFF;
  ButtonRound6.Gradient_End_Color = 0xC618;
  ButtonRound6.Color           = 0x3186;
  ButtonRound6.Press_Color     = 0x632C;
  ButtonRound6.Corner_Radius   = 3;
  ButtonRound6.OnClickPtr      = ButtonRound6OnClick;

  ButtonRound7.OwnerScreen     = &Screen1;
  ButtonRound7.Order           = 4;
  ButtonRound7.Left            = 70;
  ButtonRound7.Top             = 125;
  ButtonRound7.Width           = 35;
  ButtonRound7.Height          = 35;
  ButtonRound7.Pen_Width       = 2;
  ButtonRound7.Pen_Color       = 0xCE79;
  ButtonRound7.Visible         = 1;
  ButtonRound7.Active          = 1;
  ButtonRound7.Transparent     = 1;
  ButtonRound7.Caption         = ButtonRound7_Caption;
  ButtonRound7.TextAlign       = _taCenter;
  ButtonRound7.TextAlignVertical= _tavMiddle;
  ButtonRound7.FontName        = Tahoma21x25_Regular;
  ButtonRound7.PressColEnabled = 1;
  ButtonRound7.Font_Color      = 0xFE66;
  ButtonRound7.VerticalText    = 0;
  ButtonRound7.Gradient        = 0;
  ButtonRound7.Gradient_Orientation = 0;
  ButtonRound7.Gradient_Start_Color = 0xFFFF;
  ButtonRound7.Gradient_End_Color = 0xC618;
  ButtonRound7.Color           = 0x3186;
  ButtonRound7.Press_Color     = 0x632C;
  ButtonRound7.Corner_Radius   = 3;
  ButtonRound7.OnClickPtr      = ButtonRound7OnClick;

  ButtonRound8.OwnerScreen     = &Screen1;
  ButtonRound8.Order           = 5;
  ButtonRound8.Left            = 30;
  ButtonRound8.Top             = 125;
  ButtonRound8.Width           = 35;
  ButtonRound8.Height          = 35;
  ButtonRound8.Pen_Width       = 2;
  ButtonRound8.Pen_Color       = 0xCE79;
  ButtonRound8.Visible         = 1;
  ButtonRound8.Active          = 1;
  ButtonRound8.Transparent     = 1;
  ButtonRound8.Caption         = ButtonRound8_Caption;
  ButtonRound8.TextAlign       = _taCenter;
  ButtonRound8.TextAlignVertical= _tavMiddle;
  ButtonRound8.FontName        = Tahoma21x25_Regular;
  ButtonRound8.PressColEnabled = 1;
  ButtonRound8.Font_Color      = 0xFE66;
  ButtonRound8.VerticalText    = 0;
  ButtonRound8.Gradient        = 0;
  ButtonRound8.Gradient_Orientation = 0;
  ButtonRound8.Gradient_Start_Color = 0xFFFF;
  ButtonRound8.Gradient_End_Color = 0xC618;
  ButtonRound8.Color           = 0x3186;
  ButtonRound8.Press_Color     = 0x632C;
  ButtonRound8.Corner_Radius   = 3;
  ButtonRound8.OnClickPtr      = ButtonRound8OnClick;

  Label1.OwnerScreen     = &Screen1;
  Label1.Order           = 6;
  Label1.Left            = 25;
  Label1.Top             = 170;
  Label1.Width           = 110;
  Label1.Height          = 15;
  Label1.Visible         = 1;
  Label1.Active          = 1;
  Label1.Caption         = Label1_Caption;
  Label1.FontName        = Tahoma13x13_Bold;
  Label1.Font_Color      = 0xFE66;
  Label1.VerticalText    = 0;

  Label2.OwnerScreen     = &Screen1;
  Label2.Order           = 7;
  Label2.Left            = 25;
  Label2.Top             = 105;
  Label2.Width           = 126;
  Label2.Height          = 15;
  Label2.Visible         = 1;
  Label2.Active          = 1;
  Label2.Caption         = Label2_Caption;
  Label2.FontName        = Tahoma13x13_Bold;
  Label2.Font_Color      = 0xFE66;
  Label2.VerticalText    = 0;

  Label3.OwnerScreen     = &Screen1;
  Label3.Order           = 8;
  Label3.Left            = 100;
  Label3.Top             = 130;
  Label3.Width           = 46;
  Label3.Height          = 28;
  Label3.Visible         = 1;
  Label3.Active          = 1;
  Label3.Caption         = Label3_Caption;
  Label3.FontName        = Tahoma21x25_Regular;
  Label3.Font_Color      = 0xFE66;
  Label3.VerticalText    = 0;

  Label4.OwnerScreen     = &Screen1;
  Label4.Order           = 9;
  Label4.Left            = 99;
  Label4.Top             = 196;
  Label4.Width           = 46;
  Label4.Height          = 28;
  Label4.Visible         = 1;
  Label4.Active          = 1;
  Label4.Caption         = Label4_Caption;
  Label4.FontName        = Tahoma21x25_Regular;
  Label4.Font_Color      = 0xFE66;
  Label4.VerticalText    = 0;

  Label5.OwnerScreen     = &Screen1;
  Label5.Order           = 10;
  Label5.Left            = 165;
  Label5.Top             = 125;
  Label5.Width           = 140;
  Label5.Height          = 15;
  Label5.Visible         = 1;
  Label5.Active          = 1;
  Label5.Caption         = Label5_Caption;
  Label5.FontName        = Tahoma11x13_Regular;
  Label5.Font_Color      = 0xFE66;
  Label5.VerticalText    = 0;

  Label6.OwnerScreen     = &Screen1;
  Label6.Order           = 11;
  Label6.Left            = 165;
  Label6.Top             = 140;
  Label6.Width           = 139;
  Label6.Height          = 15;
  Label6.Visible         = 1;
  Label6.Active          = 1;
  Label6.Caption         = Label6_Caption;
  Label6.FontName        = Tahoma11x13_Regular;
  Label6.Font_Color      = 0xFE66;
  Label6.VerticalText    = 0;

  Label7.OwnerScreen     = &Screen1;
  Label7.Order           = 12;
  Label7.Left            = 165;
  Label7.Top             = 155;
  Label7.Width           = 144;
  Label7.Height          = 15;
  Label7.Visible         = 1;
  Label7.Active          = 1;
  Label7.Caption         = Label7_Caption;
  Label7.FontName        = Tahoma11x13_Regular;
  Label7.Font_Color      = 0xFE66;
  Label7.VerticalText    = 0;

  Label8.OwnerScreen     = &Screen1;
  Label8.Order           = 13;
  Label8.Left            = 165;
  Label8.Top             = 170;
  Label8.Width           = 99;
  Label8.Height          = 15;
  Label8.Visible         = 1;
  Label8.Active          = 1;
  Label8.Caption         = Label8_Caption;
  Label8.FontName        = Tahoma11x13_Regular;
  Label8.Font_Color      = 0xFE66;
  Label8.VerticalText    = 0;

  Line1.OwnerScreen     = &Screen1;
  Line1.Order           = 14;
  Line1.First_Point_X   = 221;
  Line1.First_Point_Y   = 362;
  Line1.Second_Point_X  = 321;
  Line1.Second_Point_Y  = 412;
  Line1.Visible         = 1;
  Line1.Pen_Width       = 1;
  Line1.Color           = 0x0000;

  BoxRound2.OwnerScreen     = &Screen2;
  BoxRound2.Order           = 0;
  BoxRound2.Left            = 5;
  BoxRound2.Top             = 5;
  BoxRound2.Width           = 310;
  BoxRound2.Height          = 230;
  BoxRound2.Pen_Width       = 4;
  BoxRound2.Pen_Color       = 0xFE66;
  BoxRound2.Visible         = 1;
  BoxRound2.Active          = 1;
  BoxRound2.Transparent     = 1;
  BoxRound2.Gradient        = 0;
  BoxRound2.Gradient_Orientation = 0;
  BoxRound2.Gradient_Start_Color = 0xFFFF;
  BoxRound2.Gradient_End_Color = 0xC618;
  BoxRound2.Color           = 0x3186;
  BoxRound2.PressColEnabled = 0;
  BoxRound2.Press_Color     = 0xE71C;
  BoxRound2.Corner_Radius   = 6;

  BoxRound3.OwnerScreen     = &Screen2;
  BoxRound3.Order           = 1;
  BoxRound3.Left            = 100;
  BoxRound3.Top             = 16;
  BoxRound3.Width           = 205;
  BoxRound3.Height          = 190;
  BoxRound3.Pen_Width       = 2;
  BoxRound3.Pen_Color       = 0xCE79;
  BoxRound3.Visible         = 1;
  BoxRound3.Active          = 1;
  BoxRound3.Transparent     = 1;
  BoxRound3.Gradient        = 0;
  BoxRound3.Gradient_Orientation = 0;
  BoxRound3.Gradient_Start_Color = 0xFFFF;
  BoxRound3.Gradient_End_Color = 0xC618;
  BoxRound3.Color           = 0x3186;
  BoxRound3.PressColEnabled = 0;
  BoxRound3.Press_Color     = 0xE71C;
  BoxRound3.Corner_Radius   = 4;

  ButtonRound2.OwnerScreen     = &Screen2;
  ButtonRound2.Order           = 2;
  ButtonRound2.Left            = 15;
  ButtonRound2.Top             = 135;
  ButtonRound2.Width           = 75;
  ButtonRound2.Height          = 45;
  ButtonRound2.Pen_Width       = 3;
  ButtonRound2.Pen_Color       = 0xCE79;
  ButtonRound2.Visible         = 1;
  ButtonRound2.Active          = 1;
  ButtonRound2.Transparent     = 1;
  ButtonRound2.Caption         = ButtonRound2_Caption;
  ButtonRound2.TextAlign       = _taCenter;
  ButtonRound2.TextAlignVertical= _tavMiddle;
  ButtonRound2.FontName        = Tahoma13x13_Bold;
  ButtonRound2.PressColEnabled = 1;
  ButtonRound2.Font_Color      = 0xFE66;
  ButtonRound2.VerticalText    = 0;
  ButtonRound2.Gradient        = 0;
  ButtonRound2.Gradient_Orientation = 0;
  ButtonRound2.Gradient_Start_Color = 0xFFFF;
  ButtonRound2.Gradient_End_Color = 0xC618;
  ButtonRound2.Color           = 0x3186;
  ButtonRound2.Press_Color     = 0x632C;
  ButtonRound2.Corner_Radius   = 4;
  ButtonRound2.OnClickPtr      = ButtonRound2OnClick;

  BoxRound4.OwnerScreen     = &Screen2;
  BoxRound4.Order           = 3;
  BoxRound4.Left            = 110;
  BoxRound4.Top             = 25;
  BoxRound4.Width           = 195;
  BoxRound4.Height          = 180;
  BoxRound4.Pen_Width       = 2;
  BoxRound4.Pen_Color       = 0xCE79;
  BoxRound4.Visible         = 1;
  BoxRound4.Active          = 1;
  BoxRound4.Transparent     = 1;
  BoxRound4.Gradient        = 0;
  BoxRound4.Gradient_Orientation = 0;
  BoxRound4.Gradient_Start_Color = 0xFFFF;
  BoxRound4.Gradient_End_Color = 0xC618;
  BoxRound4.Color           = 0x3186;
  BoxRound4.PressColEnabled = 0;
  BoxRound4.Press_Color     = 0xE71C;
  BoxRound4.Corner_Radius   = 4;

  ButtonRound3.OwnerScreen     = &Screen2;
  ButtonRound3.Order           = 4;
  ButtonRound3.Left            = 15;
  ButtonRound3.Top             = 15;
  ButtonRound3.Width           = 75;
  ButtonRound3.Height          = 45;
  ButtonRound3.Pen_Width       = 3;
  ButtonRound3.Pen_Color       = 0xCE79;
  ButtonRound3.Visible         = 1;
  ButtonRound3.Active          = 1;
  ButtonRound3.Transparent     = 1;
  ButtonRound3.Caption         = ButtonRound3_Caption;
  ButtonRound3.TextAlign       = _taCenter;
  ButtonRound3.TextAlignVertical= _tavMiddle;
  ButtonRound3.FontName        = Tahoma13x13_Bold;
  ButtonRound3.PressColEnabled = 1;
  ButtonRound3.Font_Color      = 0xFE66;
  ButtonRound3.VerticalText    = 0;
  ButtonRound3.Gradient        = 0;
  ButtonRound3.Gradient_Orientation = 0;
  ButtonRound3.Gradient_Start_Color = 0xFFFF;
  ButtonRound3.Gradient_End_Color = 0xC618;
  ButtonRound3.Color           = 0x3186;
  ButtonRound3.Press_Color     = 0x632C;
  ButtonRound3.Corner_Radius   = 4;
  ButtonRound3.OnClickPtr      = ButtonRound3OnClick;

  ButtonRound4.OwnerScreen     = &Screen2;
  ButtonRound4.Order           = 5;
  ButtonRound4.Left            = 15;
  ButtonRound4.Top             = 75;
  ButtonRound4.Width           = 75;
  ButtonRound4.Height          = 45;
  ButtonRound4.Pen_Width       = 3;
  ButtonRound4.Pen_Color       = 0xCE79;
  ButtonRound4.Visible         = 1;
  ButtonRound4.Active          = 1;
  ButtonRound4.Transparent     = 1;
  ButtonRound4.Caption         = ButtonRound4_Caption;
  ButtonRound4.TextAlign       = _taCenter;
  ButtonRound4.TextAlignVertical= _tavMiddle;
  ButtonRound4.FontName        = Tahoma13x13_Bold;
  ButtonRound4.PressColEnabled = 1;
  ButtonRound4.Font_Color      = 0xFE66;
  ButtonRound4.VerticalText    = 0;
  ButtonRound4.Gradient        = 0;
  ButtonRound4.Gradient_Orientation = 0;
  ButtonRound4.Gradient_Start_Color = 0xFFFF;
  ButtonRound4.Gradient_End_Color = 0xC618;
  ButtonRound4.Color           = 0x3186;
  ButtonRound4.Press_Color     = 0x632C;
  ButtonRound4.Corner_Radius   = 4;
  ButtonRound4.OnClickPtr      = ButtonRound1OnClick;
}

static char IsInsideObject (unsigned int X, unsigned int Y, unsigned int Left, unsigned int Top, unsigned int Width, unsigned int Height) { // static
  if ( (Left<= X) && (Left+ Width - 1 >= X) &&
       (Top <= Y)  && (Top + Height - 1 >= Y) )
    return 1;
  else
    return 0;
}


#define GetRoundButton(index)         CurrentScreen->Buttons_Round[index]
#define GetLabel(index)               CurrentScreen->Labels[index]
#define GetBox_Round(index)           CurrentScreen->Boxes_Round[index]
#define GetLine(index)                CurrentScreen->Lines[index]


void DrawRoundButton(TButton_Round *Around_button) {
unsigned int ALeft, ATop, point_a, point_b;
  if (Around_button->Visible != 0) {
    if (object_pressed == 1) {
      object_pressed = 0;
      TFTIntern_Set_Brush(Around_button->Transparent, Around_button->Press_Color, Around_button->Gradient, Around_button->Gradient_Orientation,
                    Around_button->Gradient_End_Color, Around_button->Gradient_Start_Color);
    }
    else {
      TFTIntern_Set_Brush(Around_button->Transparent, Around_button->Color, Around_button->Gradient, Around_button->Gradient_Orientation,
                    Around_button->Gradient_Start_Color, Around_button->Gradient_End_Color);
    }
    TFTIntern_Set_Pen(Around_button->Pen_Color, Around_button->Pen_Width);
    TFTIntern_Rectangle_Round_Edges(Around_button->Left + 1, Around_button->Top + 1,
      Around_button->Left + Around_button->Width - 2,
      Around_button->Top + Around_button->Height - 2, Around_button->Corner_Radius);
    if (Around_button->VerticalText != 0)
      TFTIntern_Set_Font(Around_button->FontName, Around_button->Font_Color, FO_VERTICAL_COLUMN_Intern);
    else
      TFTIntern_Set_Font(Around_button->FontName, Around_button->Font_Color, FO_HORIZONTAL_Intern);
    point_a = Around_button->Left;
    point_b = Around_button->Top;
    TFTIntern_Write_Text_Return_Pos(Around_button->Caption, &point_a, &point_b);
    if (Around_button->TextAlign == _taLeft)
      ALeft = Around_button->Left + 4;
    else if (Around_button->TextAlign == _taCenter)
      ALeft = Around_button->Left + (Around_button->Width - caption_length) / 2;
    else if (Around_button->TextAlign == _taRight)
      ALeft = Around_button->Left + Around_button->Width - caption_length - 4;

    if (Around_button->TextAlignVertical == _tavTop)
      ATop = Around_button->Top + 3;
    else if (Around_button->TextAlignVertical == _tavMiddle)
      ATop = Around_button->Top + (Around_button->Height - caption_height) / 2;
    else if (Around_button->TextAlignVertical == _tavBottom)
      ATop  = Around_button->Top + Around_button->Height - caption_height - 4;

    TFTIntern_Write_Text(Around_button->Caption, ALeft, ATop);
  }
}

void DrawLabel(TLabel *ALabel) {
  if (ALabel->Visible != 0) {
    if (ALabel->VerticalText != 0)
      TFTIntern_Set_Font(ALabel->FontName, ALabel->Font_Color, FO_VERTICAL_COLUMN_Intern);
    else
      TFTIntern_Set_Font(ALabel->FontName, ALabel->Font_Color, FO_HORIZONTAL_Intern);
    TFTIntern_Write_Text(ALabel->Caption, ALabel->Left, ALabel->Top);
  }
}

void DrawRoundBox(TBox_Round *Around_box) {
  if (Around_box->Visible != 0) {
    if (object_pressed == 1) {
      object_pressed = 0;
      TFTIntern_Set_Brush(Around_box->Transparent, Around_box->Press_Color, Around_box->Gradient, Around_box->Gradient_Orientation,
                    Around_box->Gradient_End_Color, Around_box->Gradient_Start_Color);
    }
    else {
      TFTIntern_Set_Brush(Around_box->Transparent, Around_box->Color, Around_box->Gradient, Around_box->Gradient_Orientation,
                    Around_box->Gradient_Start_Color, Around_box->Gradient_End_Color);
    }
    TFTIntern_Set_Pen(Around_box->Pen_Color, Around_box->Pen_Width);
    TFTIntern_Rectangle_Round_Edges(Around_box->Left + 1, Around_box->Top + 1,
      Around_box->Left + Around_box->Width - 2,
      Around_box->Top + Around_box->Height - 2, Around_box->Corner_Radius);
  }
}

void DrawLine(TLine *Aline) {
  if (Aline->Visible != 0) {
    TFTIntern_Set_Pen(Aline->Color, Aline->Pen_Width);
    TFTIntern_Line(Aline->First_Point_X, Aline->First_Point_Y, Aline->Second_Point_X, Aline->Second_Point_Y);
  }
}

void DrawScreen(TScreen *aScreen) {
 unsigned int order;
  unsigned short round_button_idx;
  TButton_Round *local_round_button;
  unsigned short label_idx;
  TLabel *local_label;
  unsigned short round_box_idx;
  TBox_Round *local_round_box;
  unsigned short line_idx;
  TLine *local_line;
  char save_bled, save_bled_direction;

  object_pressed = 0;
  order = 0;
  round_button_idx = 0;
  label_idx = 0;
  round_box_idx = 0;
  line_idx = 0;
  CurrentScreen = aScreen;

  if ((display_width != CurrentScreen->Width) || (display_height != CurrentScreen->Height)) {

  TFTIntern_RasterTimingSet(&Timings);
  TFTIntern_SetDisplaySize(320, 240);
  TFTIntern_DMAConfigSet(_TFT_INTERN_DMA_PRIORITY_7 | _TFT_INTERN_DMA_FIFORDY_512_WORDS | _TFT_INTERN_DMA_BURST_16 | _TFT_INTERN_DMA_BYTE_ORDER_0123 | _TFT_INTERN_DMA_PING_PONG);
  TFTIntern_RasterFrameBufferSet(0, (unsigned long *)(0x10000000+0x0),153600);
  TFTIntern_RasterFrameBufferSet(1, (unsigned long *)(0x10000000+0x0),153600);
  TFTIntern_RasterPaletteSet(_TFT_INTERN_PALETTE_TYPE_DIRECT, (unsigned long *)(0x10000000), 0, 0, 0);
  TFTIntern_SetMemoryStartAddr((unsigned int *)(0x10000000));
  TFTIntern_RasterEnable();



    FT5XX6_SetSize(CurrentScreen->Width, CurrentScreen->Height);
    TFTIntern_Fill_Screen(CurrentScreen->Color);
    display_width = CurrentScreen->Width;
    display_height = CurrentScreen->Height;
  }
  else
    TFTIntern_Fill_Screen(CurrentScreen->Color);


  while (order < CurrentScreen->ObjectsCount) {
    if (round_button_idx < CurrentScreen->Buttons_RoundCount) {
      local_round_button = GetRoundButton(round_button_idx);
      if (order == local_round_button->Order) {
        round_button_idx++;
        order++;
        DrawRoundButton(local_round_button);
      }
    }

    if (label_idx < CurrentScreen->LabelsCount) {
      local_label = GetLabel(label_idx);
      if (order == local_label->Order) {
        label_idx++;
        order++;
        DrawLabel(local_label);
      }
    }

    if (round_box_idx < CurrentScreen->Boxes_RoundCount) {
      local_round_box = GetBox_Round(round_box_idx);
      if (order == local_round_box->Order) {
        round_box_idx++;
        order++;
        DrawRoundBox(local_round_box);
      }
    }

    if (line_idx < CurrentScreen->LinesCount) {
      local_line = GetLine(line_idx);
      if (order == local_line->Order) {
        line_idx++;
        order++;
        DrawLine(local_line);
      }
    }

  }
}

void Get_Object(unsigned int X, unsigned int Y) {
  round_button_order  = -1;
  label_order         = -1;
  box_round_order     = -1;
  //  Buttons with Round Edges
  for ( _object_count = 0 ; _object_count < CurrentScreen->Buttons_RoundCount ; _object_count++ ) {
    local_round_button = GetRoundButton(_object_count);
    if (local_round_button->Active != 0) {
      if (IsInsideObject(X, Y, local_round_button->Left, local_round_button->Top,
                         local_round_button->Width, local_round_button->Height) == 1) {
        round_button_order = local_round_button->Order;
        exec_round_button = local_round_button;
      }
    }
  }

  //  Labels
  for ( _object_count = 0 ; _object_count < CurrentScreen->LabelsCount ; _object_count++ ) {
    local_label = GetLabel(_object_count);
    if (local_label->Active != 0) {
      if (IsInsideObject(X, Y, local_label->Left, local_label->Top,
                         local_label->Width, local_label->Height) == 1) {
        label_order = local_label->Order;
        exec_label = local_label;
      }
    }
  }

  //  Boxes with Round Edges
  for ( _object_count = 0 ; _object_count < CurrentScreen->Boxes_RoundCount ; _object_count++ ) {
    local_round_box = GetBox_Round(_object_count);
    if (local_round_box->Active != 0) {
      if (IsInsideObject(X, Y, local_round_box->Left, local_round_box->Top,
                         local_round_box->Width, local_round_box->Height) == 1) {
        box_round_order = local_round_box->Order;
        exec_round_box = local_round_box;
      }
    }
  }

  _object_count = -1;
  if (round_button_order >  _object_count )
    _object_count = round_button_order;
  if (label_order >  _object_count )
    _object_count = label_order;
  if (box_round_order >  _object_count )
    _object_count = box_round_order;
}


void Process_TP_Press(unsigned int X, unsigned int Y) {
  exec_round_button   = 0;
  exec_label          = 0;
  exec_round_box      = 0;

  Get_Object(X, Y);

  if (_object_count != -1) {
    if (_object_count == round_button_order) {
      if (exec_round_button->Active != 0) {
        if (exec_round_button->OnPressPtr != 0) {
          exec_round_button->OnPressPtr();
          return;
        }
      }
    }

    if (_object_count == label_order) {
      if (exec_label->Active != 0) {
        if (exec_label->OnPressPtr != 0) {
          exec_label->OnPressPtr();
          return;
        }
      }
    }

    if (_object_count == box_round_order) {
      if (exec_round_box->Active != 0) {
        if (exec_round_box->OnPressPtr != 0) {
          exec_round_box->OnPressPtr();
          return;
        }
      }
    }

  }
}

void Process_TP_Up(unsigned int X, unsigned int Y) {

  switch (PressedObjectType) {
    // Round Button
    case 1: {
      if (PressedObject != 0) {
        exec_round_button = (TButton_Round*)PressedObject;
        if ((exec_round_button->PressColEnabled != 0) && (exec_round_button->OwnerScreen == CurrentScreen)) {
          DrawRoundButton(exec_round_button);
        }
        break;
      }
      break;
    }
    // Round Box
    case 7: {
      if (PressedObject != 0) {
        exec_round_box = (TBox_Round*)PressedObject;
        if ((exec_round_box->PressColEnabled != 0) && (exec_round_box->OwnerScreen == CurrentScreen)) {
          DrawRoundBox(exec_round_box);
        }
        break;
      }
      break;
    }
  }

  exec_label          = 0;

  Get_Object(X, Y);


  if (_object_count != -1) {
  // Buttons with Round Edges
    if (_object_count == round_button_order) {
      if (exec_round_button->Active != 0) {
        if (exec_round_button->OnUpPtr != 0)
          exec_round_button->OnUpPtr();
        if (PressedObject == (void *)exec_round_button)
          if (exec_round_button->OnClickPtr != 0)
            exec_round_button->OnClickPtr();
        PressedObject = 0;
        PressedObjectType = -1;
        return;
      }
    }

  // Labels
    if (_object_count == label_order) {
      if (exec_label->Active != 0) {
        if (exec_label->OnUpPtr != 0)
          exec_label->OnUpPtr();
        if (PressedObject == (void *)exec_label)
          if (exec_label->OnClickPtr != 0)
            exec_label->OnClickPtr();
        PressedObject = 0;
        PressedObjectType = -1;
        return;
      }
    }

  // Boxes with Round Edges
    if (_object_count == box_round_order) {
      if (exec_round_box->Active != 0) {
        if (exec_round_box->OnUpPtr != 0)
          exec_round_box->OnUpPtr();
        if (PressedObject == (void *)exec_round_box)
          if (exec_round_box->OnClickPtr != 0)
            exec_round_box->OnClickPtr();
        PressedObject = 0;
        PressedObjectType = -1;
        return;
      }
    }

  }
  PressedObject = 0;
  PressedObjectType = -1;
}

void Process_TP_Down(unsigned int X, unsigned int Y) {

  object_pressed      = 0;
  exec_round_button   = 0;
  exec_label          = 0;
  exec_round_box      = 0;

  Get_Object(X, Y);

  if (_object_count != -1) {
    if (_object_count == round_button_order) {
      if (exec_round_button->Active != 0) {
        if (exec_round_button->PressColEnabled != 0) {
          object_pressed = 1;
          DrawRoundButton(exec_round_button);
        }
        PressedObject = (void *)exec_round_button;
        PressedObjectType = 1;
        if (exec_round_button->OnDownPtr != 0) {
          exec_round_button->OnDownPtr();
          return;
        }
      }
    }

    if (_object_count == label_order) {
      if (exec_label->Active != 0) {
        PressedObject = (void *)exec_label;
        PressedObjectType = 2;
        if (exec_label->OnDownPtr != 0) {
          exec_label->OnDownPtr();
          return;
        }
      }
    }

    if (_object_count == box_round_order) {
      if (exec_round_box->Active != 0) {
        if (exec_round_box->PressColEnabled != 0) {
          object_pressed = 1;
          DrawRoundBox(exec_round_box);
        }
        PressedObject = (void *)exec_round_box;
        PressedObjectType = 7;
        if (exec_round_box->OnDownPtr != 0) {
          exec_round_box->OnDownPtr();
          return;
        }
      }
    }

  }
}

void Process_TP_Gesture(unsigned short aGestID) {
  if ((aGestID == ft5xx6_gest_move_up) && (CurrentScreen->OnSwipeUpPtr != 0)){
    CurrentScreen->OnSwipeUpPtr() ;
  }
  if ((aGestID == ft5xx6_gest_move_left) && (CurrentScreen->OnSwipeLeftPtr != 0)){
    CurrentScreen->OnSwipeLeftPtr() ;
  }
  if ((aGestID == ft5xx6_gest_move_down) && (CurrentScreen->OnSwipeDownPtr != 0)){
    CurrentScreen->OnSwipeDownPtr() ;
  }
  if ((aGestID == ft5xx6_gest_move_right) && (CurrentScreen->OnSwipeRightPtr != 0)){
    CurrentScreen->OnSwipeRightPtr() ;
  }
  if ((aGestID == FT5XX6_GEST_ZOOM_IN) && (CurrentScreen->OnZoomInPtr != 0)){
    CurrentScreen->OnZoomInPtr() ;
  }
  if ((aGestID == FT5XX6_GEST_ZOOM_OUT) && (CurrentScreen->OnZoomOutPtr != 0)){
    CurrentScreen->OnZoomOutPtr() ;
  }
}

void Check_TP() {
unsigned short gestureid;
  if (FT5XX6_PressDetect()) {
    gestureid = FT5XX6_GetGesture();
    if (gestureid) {
      Process_TP_Gesture(gestureid);
    }
    if (FT5XX6_GetCoordinates(&Xcoord, &Ycoord) == 0) {
    // After a PRESS is detected read X-Y and convert it to Display dimensions space
      Process_TP_Press(Xcoord, Ycoord);
      if (PenDown == 0) {
        PenDown = 1;
        Process_TP_Down(Xcoord, Ycoord);
      }
    }
  }
  else if (PenDown == 1) {
    PenDown = 0;
    Process_TP_Up(Xcoord, Ycoord);
  }
}

void Init_MCU()
{
// If bus is busy wait SDA high before initializing I2C module
GPIO_Digital_Output(&GPIO_PORTD_AHB, _GPIO_PINMASK_2);
  GPIO_Digital_Input(&GPIO_PORTD_AHB, _GPIO_PINMASK_3);
  GPIO_PORTD_AHB_DATA.B2 = 1;

  while (GPIO_PORTD_AHB_DATA.B3 == 0) {
    GPIO_PORTD_AHB_DATA.B2 = 0;
    Delay_us(10);
    GPIO_PORTD_AHB_DATA.B2 = 1;
    Delay_us(10);
  }

  delay_ms(100);
  I2C8_Init_Advanced(_I2C_BITRATE_FAST_MODE, &_GPIO_MODULE_I2C8_D23_AHB);

    Delay_100ms( );
    Delay_100ms( );
    Delay_100ms( );
    Delay_100ms( );
    Delay_100ms( );


//  TFTIntern_SetDefaultMode();
  FT5XX6_SetDefaultMode();
}

char FT5XX6_Config()  {
  FT5XX6_SetI2CAddress(0x38);
  if (FT5XX6_IsOperational() != FT5XX6_OK)
    return  FT5XX6_FAILURE;
  FT5XX6_SetDefaultMode();
  FT5XX6_SetController(_TC_FT5X46);
  FT5XX6_SetSizeAndRotation(320,240,2);
return FT5XX6_OK;
}

void Start_TP() {
  Init_MCU();

  InitializeTouchPanel();
  if (FT5XX6_Config() == FT5XX6_OK) {
  } else {
    while(1);
  }


  InitializeObjects();
  display_width = Screen1.Width;
  display_height = Screen1.Height;
  DrawScreen(&Screen1);
  
}